diff -r ec894ddf18f6 trytond/modules/calendar/webdav.py
--- a/trytond/modules/calendar/webdav.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/webdav.py	Mon Sep 24 20:36:40 2012 +0200
@@ -431,200 +435,210 @@
                 red_sql, red_ids = reduce_ids('calendar', sub_ids)
                 cursor.execute('SELECT calendar, MAX(EXTRACT(epoch FROM ' \
                             'COALESCE(write_date, create_date))) ' \
-                        'FROM "' + event_obj._table + '" ' \
+                        'FROM "' + Event._table + '" ' \
                         'WHERE ' + red_sql + ' ' \
                         'GROUP BY calendar', red_ids)
                 for calendar_id2, date in cursor.fetchall():
                     if calendar_id2 == calendar_ics_id:
                         res = date
                     if cache is not None:
-                        cache['_calendar'][calendar_obj._name]\
+                        cache['_calendar'][Calendar.__name__]\
                                 .setdefault(calendar_id2, {})
-                        cache['_calendar'][calendar_obj._name][
+                        cache['_calendar'][Calendar.__name__][
                             calendar_id2]['lastmodified ics'] = date
             if res is not None:
                 return res
-        return super(Collection, self).get_lastmodified(uri, cache=cache)
+        return super(Collection, cls).get_lastmodified(uri, cache=cache)
 
-    def get_data(self, uri, cache=None):
-        event_obj = Pool().get('calendar.event')
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def get_data(cls, uri, cache=None):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Calendar = pool.get('calendar.calendar')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 raise DAV_NotFound
-            event_id = self.event(uri, calendar_id=calendar_id)
+            event_id = cls.event(uri, calendar_id=calendar_id)
             if not event_id:
                 raise DAV_NotFound
-            ical = event_obj.event2ical(event_id)
+            ical = Event.event2ical(event_id)
             return ical.serialize()
-        calendar_ics_id = self.calendar(uri, ics=True)
+        calendar_ics_id = cls.calendar(uri, ics=True)
         if calendar_ics_id:
-            ical = calendar_obj.calendar2ical(calendar_ics_id)
+            ical = Calendar.calendar2ical(calendar_ics_id)
             return ical.serialize()
-        return super(Collection, self).get_data(uri, cache=cache)
+        return super(Collection, cls).get_data(uri, cache=cache)
 
-    def get_calendar_description(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def get_calendar_description(cls, uri, cache=None):
+        Calendar = Pool().get('calendar.calendar')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(calendar_obj._name, {})
-                    ids = cache['_calendar'][calendar_obj._name].keys()
+                    cache['_calendar'].setdefault(Calendar.__name__, {})
+                    ids = cache['_calendar'][Calendar.__name__].keys()
                     if calendar_id not in ids:
                         ids.append(calendar_id)
                     elif 'calendar_description' in cache['_calendar'][
-                            calendar_obj._name][calendar_id]:
-                        res = cache['_calendar'][calendar_obj._name][
+                            Calendar.__name__][calendar_id]:
+                        res = cache['_calendar'][Calendar.__name__][
                             calendar_id]['calendar_description']
                         if res is not None:
                             return res
                 else:
                     ids = [calendar_id]
                 res = None
-                for calendar in calendar_obj.browse(ids):
+                for calendar in Calendar.browse(ids):
                     if calendar.id == calendar_id:
                         res = calendar.description
                     if cache is not None:
-                        cache['_calendar'][calendar_obj._name]\
+                        cache['_calendar'][Calendar.__name__]\
                                 .setdefault(calendar.id, {})
-                        cache['_calendar'][calendar_obj._name][
+                        cache['_calendar'][Calendar.__name__][
                             calendar.id]['calendar_description'] = \
                                 calendar.description
                 if res is not None:
                     return res
         raise DAV_NotFound
 
-    def get_calendar_data(self, uri, cache=None):
-        return self.get_data(uri, cache=cache).decode('utf-8')
+    @classmethod
+    def get_calendar_data(cls, uri, cache=None):
+        return cls.get_data(uri, cache=cache).decode('utf-8')
 
-    def get_calendar_home_set(self, uri, cache=None):
+    @staticmethod
+    def get_calendar_home_set(uri, cache=None):
         return '/Calendars'
 
-    def get_calendar_user_address_set(self, uri, cache=None):
-        user_obj = Pool().get('res.user')
-        user = user_obj.browse(Transaction().user)
+    @staticmethod
+    def get_calendar_user_address_set(uri, cache=None):
+        User = Pool().get('res.user')
+        user = User(Transaction().user)
         if user.email:
             return user.email
         raise DAV_NotFound
 
-    def get_schedule_inbox_URL(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
+    @staticmethod
+    def get_schedule_inbox_URL(uri, cache=None):
+        Calendar = Pool().get('calendar.calendar')
         user = Transaction().user
 
-        calendar_ids = calendar_obj.search([
+        calendars = Calendar.search([
             ('owner', '=', user),
             ], limit=1)
-        if not calendar_ids:
+        if not calendars:
             # Sunbird failed with no value
             return '/Calendars'
-        calendar = calendar_obj.browse(calendar_ids[0])
+        calendar, = calendars
         return '/Calendars/' + calendar.name
 
-    def get_schedule_outbox_URL(self, uri, cache=None):
-        return self.get_schedule_inbox_URL(uri, cache=cache)
+    @classmethod
+    def get_schedule_outbox_URL(cls, uri, cache=None):
+        return cls.get_schedule_inbox_URL(uri, cache=cache)
 
-    def put(self, uri, data, content_type, cache=None):
-        event_obj = Pool().get('calendar.event')
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def put(cls, uri, data, content_type, cache=None):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Calendar = pool.get('calendar.calendar')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 raise DAV_Forbidden
-            event_id = self.event(uri, calendar_id=calendar_id)
+            event_id = cls.event(uri, calendar_id=calendar_id)
             if not event_id:
                 ical = vobject.readOne(data)
-                values = event_obj.ical2values(None, ical, calendar_id)
-                event_id = event_obj.create(values)
-                event = event_obj.browse(event_id)
-                calendar = calendar_obj.browse(calendar_id)
+                values = Event.ical2values(None, ical, calendar_id)
+                event = Event.create(values)
+                calendar = Calendar(calendar_id)
                 return (Transaction().cursor.database_name + '/Calendars/' +
                         calendar.name + '/' + event.uuid + '.ics')
             else:
                 ical = vobject.readOne(data)
-                values = event_obj.ical2values(event_id, ical, calendar_id)
-                event_obj.write(event_id, values)
+                values = Event.ical2values(event_id, ical, calendar_id)
+                Event.write([Event(event_id)], values)
                 return
-        calendar_ics_id = self.calendar(uri, ics=True)
+        calendar_ics_id = cls.calendar(uri, ics=True)
         if calendar_ics_id:
             raise DAV_Forbidden
-        return super(Collection, self).put(uri, data, content_type)
+        return super(Collection, cls).put(uri, data, content_type)
 
-    def mkcol(self, uri, cache=None):
+    @classmethod
+    def mkcol(cls, uri, cache=None):
         if uri and uri.startswith('Calendars/'):
             raise DAV_Forbidden
-        return super(Collection, self).mkcol(uri, cache=cache)
+        return super(Collection, cls).mkcol(uri, cache=cache)
 
-    def rmcol(self, uri, cache=None):
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def rmcol(cls, uri, cache=None):
+        Calendar = Pool().get('calendar.calendar')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 try:
-                    calendar_obj.delete(calendar_id)
+                    Calendar.delete([Calendar(calendar_id)])
                 except Exception:
                     raise DAV_Forbidden
                 return 200
             raise DAV_Forbidden
-        return super(Collection, self).rmcol(uri, cache=cache)
+        return super(Collection, cls).rmcol(uri, cache=cache)
 
-    def rm(self, uri, cache=None):
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def rm(cls, uri, cache=None):
+        Event = Pool().get('calendar.event')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 return 403
-            event_id = self.event(uri, calendar_id=calendar_id)
+            event_id = cls.event(uri, calendar_id=calendar_id)
             if event_id:
                 try:
-                    event_obj.delete(event_id)
+                    Event.delete([Event(event_id)])
                 except Exception:
                     return 403
                 return 200
             return 404
-        calendar_ics_id = self.calendar(uri, ics=True)
+        calendar_ics_id = cls.calendar(uri, ics=True)
         if calendar_ics_id:
             return 403
-        return super(Collection, self).rm(uri, cache=cache)
+        return super(Collection, cls).rm(uri, cache=cache)
 
-    def exists(self, uri, cache=None):
+    @classmethod
+    def exists(cls, uri, cache=None):
         if uri in ('Calendars', 'Calendars/'):
             return 1
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 return 1
-            if self.event(uri, calendar_id=calendar_id):
+            if cls.event(uri, calendar_id=calendar_id):
                 return 1
-        calendar_ics_id = self.calendar(uri, ics=True)
+        calendar_ics_id = cls.calendar(uri, ics=True)
         if calendar_ics_id:
             return 1
-        return super(Collection, self).exists(uri, cache=cache)
+        return super(Collection, cls).exists(uri, cache=cache)
 
-    def current_user_privilege_set(self, uri, cache=None):
+    @classmethod
+    def current_user_privilege_set(cls, uri, cache=None):
         '''
         Return the privileges of the current user for uri
         Privileges ares: create, read, write, delete
-
-        :param uri: the uri
-        :param cache: the cache
-        :return: a list of privileges
         '''
-        calendar_obj = Pool().get('calendar.calendar')
+        Calendar = Pool().get('calendar.calendar')
 
         if uri in ('Calendars', 'Calendars/'):
             return ['create', 'read', 'write', 'delete']
         if uri and uri.startswith('Calendars/'):
-            calendar_id = self.calendar(uri)
+            calendar_id = cls.calendar(uri)
             if calendar_id:
-                calendar = calendar_obj.browse(calendar_id)
+                calendar = Calendar(calendar_id)
                 user = Transaction().user
                 if user == calendar.owner.id:
                     return ['create', 'read', 'write', 'delete']
@@ -635,7 +649,5 @@
                     res.extend(['read', 'write', 'delete'])
                 return res
             return []
-        return super(Collection, self).current_user_privilege_set(uri,
-                cache=cache)
-
-Collection()
+        return super(Collection, cls).current_user_privilege_set(uri,
+            cache=cache)
diff -r 74d42794032d trytond/modules/calendar_classification/__init__.py
--- a/trytond/modules/calendar_classification/__init__.py	Wed Jul 25 20:48:29 2012 +0200
+++ b/trytond/modules/calendar_classification/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .calendar_ import *
+
+
+def register():
+    Pool.register(
+        Event,
+        module='calendar_classification', type_='model')
diff -r 74d42794032d trytond/modules/calendar_classification/calendar_.py
--- a/trytond/modules/calendar_classification/calendar_.py	Wed Jul 25 20:48:29 2012 +0200
+++ b/trytond/modules/calendar_classification/calendar_.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,23 +1,29 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 import vobject
-from trytond.model import ModelSQL
+
 from trytond.tools import reduce_ids
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
 
-class Event(ModelSQL):
-    _name = 'calendar.event'
+__all__ = ['Event']
+__metaclass__ = PoolMeta
 
-    def __init__(self):
-        super(Event, self).__init__()
-        self._error_messages.update({
+
+class Event:
+    __name__ = 'calendar.event'
+
+    @classmethod
+    def __setup__(cls):
+        super(Event, cls).__setup__()
+        cls._error_messages.update({
             'transparent': 'Free',
             'opaque': 'Busy',
             })
 
-    def search(self, domain, offset=0, limit=None, order=None, count=False,
+    @classmethod
+    def search(cls, domain, offset=0, limit=None, order=None, count=False,
             query_string=False):
         if Transaction().user:
             domain = domain[:]
@@ -33,23 +39,22 @@
                     ('classification', '!=', 'confidential'),
                     ],
                 ]
-        return super(Event, self).search(domain, offset=offset, limit=limit,
-                order=order, count=count, query_string=query_string)
+        return super(Event, cls).search(domain, offset=offset, limit=limit,
+            order=order, count=count, query_string=query_string)
 
-    def create(self, values):
-        new_id = super(Event, self).create(values)
-        if self.search([('id', '=', new_id)], count=True) != 1:
-            self.raise_user_error('access_error', self._description)
-        return new_id
+    @classmethod
+    def create(cls, values):
+        event = super(Event, cls).create(values)
+        if cls.search([('id', '=', event.id)], count=True) != 1:
+            cls.raise_user_error('access_error', cls.__doc__)
+        return event
 
-    def _clean_private(self, record, transp):
+    @classmethod
+    def _clean_private(cls, record, transp):
         '''
         Clean private record
-
-        :param record: a dictionary with record values
-        :param transp: the time transparency
         '''
-        summary = self.raise_user_error(transp, raise_exception=False)
+        summary = cls.raise_user_error(transp, raise_exception=False)
         if 'summary' in record:
             record['summary'] = summary
 
@@ -79,26 +84,23 @@
         if vevent:
             record['vevent'] = vevent.serialize()
 
-    def read(self, ids, fields_names=None):
-        rule_obj = Pool().get('ir.rule')
+    @classmethod
+    def read(cls, ids, fields_names=None):
+        Rule = Pool().get('ir.rule')
         cursor = Transaction().cursor
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
-        if len({}.fromkeys(ids)) != self.search([('id', 'in', ids)],
+        if len(set(ids)) != cls.search([('id', 'in', ids)],
                 count=True):
-            self.raise_user_error('access_error', self._description)
+            cls.raise_user_error('access_error', cls.__doc__)
 
         writable_ids = []
-        domain1, domain2 = rule_obj.domain_get(self._name, mode='write')
+        domain1, domain2 = Rule.domain_get(cls.__name__, mode='write')
         if domain1:
             for i in range(0, len(ids), cursor.IN_MAX):
                 sub_ids = ids[i:i + cursor.IN_MAX]
                 red_sql, red_ids = reduce_ids('id', sub_ids)
-                cursor.execute('SELECT id FROM "' + self._table + '" ' \
-                        'WHERE ' + red_sql + ' AND (' + domain1 + ')',
-                        red_ids + domain2)
+                cursor.execute('SELECT id FROM "' + cls._table + '" '
+                    'WHERE ' + red_sql + ' AND (' + domain1 + ')',
+                    red_ids + domain2)
                 writable_ids.extend(x[0] for x in cursor.fetchall())
         else:
             writable_ids = ids
@@ -112,35 +114,28 @@
             if field not in fields_names:
                 fields_names.append(field)
                 to_remove.add(field)
-        res = super(Event, self).read(ids, fields_names=fields_names)
+        res = super(Event, cls).read(ids, fields_names=fields_names)
         for record in res:
             if record['classification'] == 'private' \
                     and record['id'] not in writable_ids:
-                self._clean_private(record, record['transp'])
+                cls._clean_private(record, record['transp'])
             for field in to_remove:
                 del record[field]
-        if int_id:
-            return res[0]
         return res
 
-    def write(self, ids, values):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        if len({}.fromkeys(ids)) != self.search([('id', 'in', ids)],
+    @classmethod
+    def write(cls, events, values):
+        if len(set(events)) != cls.search([('id', 'in', map(int, events))],
                 count=True):
-            self.raise_user_error('access_error', self._description)
-        res = super(Event, self).write(ids, values)
-        if len({}.fromkeys(ids)) != self.search([('id', 'in', ids)],
+            cls.raise_user_error('access_error', cls.__doc__)
+        super(Event, cls).write(events, values)
+        if len(set(events)) != cls.search([('id', 'in', map(int, events))],
                 count=True):
-            self.raise_user_error('access_error', self._description)
-        return res
+            cls.raise_user_error('access_error', cls.__doc__)
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        if len({}.fromkeys(ids)) != self.search([('id', 'in', ids)],
+    @classmethod
+    def delete(cls, events):
+        if len(set(events)) != cls.search([('id', 'in', map(int, events))],
                 count=True):
-            self.raise_user_error('access_error', self._description)
-        return super(Event, self).delete(ids)
-
-Event()
+            cls.raise_user_error('access_error', cls.__doc__)
+        super(Event, cls).delete(events)
diff -r 189608575f90 trytond/modules/calendar_scheduling/__init__.py
--- a/trytond/modules/calendar_scheduling/__init__.py	Sat Aug 11 11:56:24 2012 +0200
+++ b/trytond/modules/calendar_scheduling/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,6 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from . import caldav
 from .calendar_ import *
 from .res import *
+
+
+def register():
+    Pool.register(
+        Event,
+        Attendee,
+        EventAttendee,
+        User,
+        module='calendar_scheduling', type_='model')
